//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37F0C8ED7480.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37F0C8ED7480.cm

//## begin module%37F0C8ED7480.cp preserve=no
//## end module%37F0C8ED7480.cp

//## Module: AddComponent%37F0C8ED7480; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/AddComponent.h

#ifndef ADDCOMPONENT_H
#define ADDCOMPONENT_H 1

//## begin module%37F0C8ED7480.additionalIncludes preserve=no
//## end module%37F0C8ED7480.additionalIncludes

//## begin module%37F0C8ED7480.includes preserve=yes
//## end module%37F0C8ED7480.includes

// Component
#include <XSModel/Model/Component/Component.h>
//## begin module%37F0C8ED7480.declarations preserve=no
//## end module%37F0C8ED7480.declarations

//## begin module%37F0C8ED7480.additionalDeclarations preserve=yes
class SumComponent;
//## end module%37F0C8ED7480.additionalDeclarations


//## begin AddComponent%362809470320.preface preserve=yes
//## end AddComponent%362809470320.preface

//## Class: AddComponent%362809470320
//	Additive Component. Derived Class Component extended by
//	defining its combination operation.
//
//	The Additive component also extends the Component class
//	by the addition of a normalization parameter.
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A8BF4010160;ComponentBase { -> }
//## Uses: <unnamed>%374D98C9B770;protected: Component { -> }

class AddComponent : public Component  //## Inherits: <unnamed>%3687BAA76668
{
  //## begin AddComponent%362809470320.initialDeclarations preserve=yes
  //## end AddComponent%362809470320.initialDeclarations

  public:
    //## Constructors (generated)
      AddComponent(const AddComponent &right);

    //## Constructors (specified)
      //## Operation: AddComponent%37EF952529B0;    C++
      AddComponent (CGroupBase* p);

    //## Destructor (generated)
      virtual ~AddComponent();


    //## Other Operations (specified)
      //## Operation: clone%38E3B8D44118
      virtual AddComponent* clone (CGroupBase* p) const;

      //## Operation: norm%3AD4AA4F00B1
      virtual Real norm () const;

      //## Operation: calculate%3ADB03ED02AF;            C++
      virtual void calculate (bool saveComponentFlux, bool frozen);

    // Additional Public Declarations
      //## begin AddComponent%362809470320.public preserve=yes
      //## end AddComponent%362809470320.public

  protected:

    //## Other Operations (specified)
      //## Operation: swap%3A953DE30013
      virtual void swap (Component& right);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: normParNum%374D98C9B76B
      //	The number identifying the normalization parameter. The
      //	parameter itself can be retrieved from the parameterSet
      //	vector using the array operator
      //		(another way of doing this would be to store an
      //	iterator,
      //	(another way of doing this would be to store an iterator,
      //	but that seems less storage wise).
      const int normParNum () const;
      void normParNum (int value);

    // Additional Protected Declarations
      //## begin AddComponent%362809470320.protected preserve=yes
      //## end AddComponent%362809470320.protected

  private:

    //## Other Operations (specified)
      //## Operation: read%374D98C9B76F;        C++
      virtual int read ();

      //## Operation: copy%3A953DDA02D9
      virtual void copy (const Component& right);

    // Additional Private Declarations
      //## begin AddComponent%362809470320.private preserve=yes
      //## end AddComponent%362809470320.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin AddComponent::normParNum%374D98C9B76B.attr preserve=no  protected: int {U} 0
      int m_normParNum;
      //## end AddComponent::normParNum%374D98C9B76B.attr

    // Additional Implementation Declarations
      //## begin AddComponent%362809470320.implementation preserve=yes
      //## end AddComponent%362809470320.implementation

};

//## begin AddComponent%362809470320.postscript preserve=yes
//## end AddComponent%362809470320.postscript

// Class AddComponent 

//## Get and Set Operations for Class Attributes (inline)

inline const int AddComponent::normParNum () const
{
  //## begin AddComponent::normParNum%374D98C9B76B.get preserve=no
  return m_normParNum;
  //## end AddComponent::normParNum%374D98C9B76B.get
}

inline void AddComponent::normParNum (int value)
{
  //## begin AddComponent::normParNum%374D98C9B76B.set preserve=no
  m_normParNum = value;
  //## end AddComponent::normParNum%374D98C9B76B.set
}

//## begin module%37F0C8ED7480.epilog preserve=yes
//## end module%37F0C8ED7480.epilog


#endif
